;SNAKES! v1.11 by Robin Harbron (c)1993
;current version 93.04.21
;for Dr. Hasegawa / Math 2473
;
; Instructions:
; Your player is an asterisk (*).  He is moved with the keys I-up,
; J-left, K-down, L-right.  There are three(3) snakes after you,
; represented by (S).  If you are touched by a snake, you lose a
; life.  You have three lives until your game is over.  To kill the
; snakes, push the blocks (O) in such a way as to surround the snakes
; in all 8 directions:  OOO
;                       OSO  When this is done, the snake will die and
;                       OOO  disappear.  When all three snakes are 
; killed, a new level is drawn up with more snakes.  This proceedes
; until you have lost all lives.  Have fun!
; Press ESC to exit when in the game, and SPACE BAR to start the game
; and to resume your game when killed.
; Adjust lines 205 and 221 to change speed of play. (Both are commented).

data    segment
score   db 1,2,1,1,2,1,4,1,6,1,5,1,4,1
        db 1,2,1,1,2,1,4,1,6,1,5,1,4,1
        db 3,2,3,1,5,1,8,1,10,1,9,1,8,1
        db 1,2,1,1,2,1,4,1,6,1,5,1,4,1
        db 4,2,4,1,7,1,9,1,12,1,11,1,9,1
        db 3,2,3,1,5,1,8,1,10,1,9,1,8,1
        db 1,2,1,1,2,1,4,1,6,1,5,1,4,1
        db 4,2
notes   dw 0
        dw 17c8h,12dfh,11cah,0fdah,0e20h,0d5bh
        dw 0c99h,0be4h,0a98h,0a00h,096fh,08e9h
length  db 1,2,4,8,16,32
int1    db 0
int2    db 0
int3    db 0
int4    db 0
int5    db 0
old     dw 326
new     dw 326
scount  dw 1
snake   dw 0,1000,2000,3000
;snake   dw 0,0,0,0
lives   db 3
level   db 1
bar     db '                    LIVES:00                     LEVEL:00',0
ldone   db ' L E V E L  C O M P L E T E ',0
game    db ' G A M E  O V E R ',0
title1  db '                                 S N A K E S !',0
title2  db '                                      by',0
title3  db '                     Robin Harbron           April 1993',0
title4  db '                          for Dr.Hasegawa in Math 2473',0
title5  db '                          Use:         I      for UP',0
title6  db '                        for LEFT    J     L    for RIGHT',0
title7  db '                                       K      for DOWN',0
title8  db '                           **Press SPACE to start!**',0
data    ends

stack   segment stack
        db 200h dup(?)
stack   ends

main    segment
assume  cs:main, ds:data, ss:stack
drive   proc far
        push ds
        call setup
        call clear
        call ptitle
        call clear
        call screen
        call plives
        call plevel
        call blocks
        call music
        call unsetup
        mov ax,4c00h
        int 21h
drive   endp

status  proc
        push ds
        mov ax,data
        mov ds,ax
        ret
status  endp

ptitle  proc
        push ax
        push bx
        push cx
        push ds
lines:  push ax
        push bx
        push ds
        mov ax,data
        mov ds,ax
        mov ax,offset title1
        mov bx,160
        call print
        mov ax,offset title2
        mov bx,480
        call print
        mov ax,offset title3
        mov bx,800
        call print
        mov ax,offset title4
        mov bx,3520
        call print
        mov ax,offset title5
        mov bx,1760
        call print
        mov ax,offset title6
        mov bx,2080
        call print
        mov ax,offset title7
        mov bx,2400
        call print
        mov ax,offset title8
        mov bx,3040
        call print
        pop ds
        pop bx
        pop ax
        call wait
        pop ds
        pop cx
        pop bx
        pop ax
        ret
ptitle  endp

wait    proc
        call fini
lp5:    cmp dl,0ffh
        jne lp5
lp4:    cmp dl,39h
        jne lp4
        call init
        ret
wait    endp

music   proc
start:  call init
repeat2:mov cx,1
        mov ax,data
        mov ds,ax
        mov si,0
play:   mov al,[si]
        add al,al
        mov ah,0
        mov di,ax
        mov cx,notes[di]
        cmp cx,0
        je oncemore
        mov al,cl
        out 42h,al
        mov al,ch
        out 42h,al
        inc si
        mov al,[si]
        mov ah,0
        mov di,ax
        mov al,length[di]
        call time
        inc si 
        jmp play
oncemore: 
;        call unsetup
;        call fini
;        mov ax,32
;        call time
        jmp repeat2
music   endp

init    proc
        push ax
        in al,61h
        or al,3
        out 61h,al
        mov al,0b6h
        out 43h,al
        pop ax
        ret
init    endp

fini    proc
        push ax
        in al,61h
        and al,0fch
        out 61h,al
        pop ax
        ret
fini    endp
 
exit    proc         
        call unsetup
        call fini
        mov ax,4c00h
        int 21h
exit    endp

delay   proc
        call scan
        push cx
        mov cx,0ffffh   ; Lower this value to speed up game!
repeat: nop
        dec cx
        jnz repeat
        pop cx
        cmp dl,1
        je finish
        push ds
        push ax
        mov ax,data
        mov ds,ax
        mov ax,[scount]
        dec ax
        cmp ax,0
        jne nxt2
        call mvsnake
        mov ax,5        ; Raise this value to slow down snakes!
nxt2:   mov [scount],ax
        pop ax
        pop ds
        cmp dl,0ffh
        je bye1
        call player
bye1:   ret
finish: call exit
delay   endp

time    proc
        push ax
again:  dec ax
        jl back
        call delay
        jmp again
back:   pop ax
        ret
time    endp

scan    proc
        mov dl,0ffh
        cli
        cmp dl,0ffh
        sti
done2:  ret
scan    endp

setup   proc
        push ax
        push bx
        push cx
        push ds
        push di
        mov ax,0
        mov ds,ax
        mov di,36
        cli
        mov ax,offset mykey
        mov bl,[di]
        push ds
        mov cx,data
        mov ds,cx
        mov [int2],bl
        pop ds
        mov [di],al
        inc di
        mov bl,[di]
        push ds
        mov ds,cx
        mov [int3],bl
        pop ds
        mov [di],ah
        inc di
        mov ax,cs
        mov bl,[di]
        push ds
        mov ds,cx
        mov [int4],bl
        pop ds
        mov [di],al
        inc di
        mov bl,[di]
        push ds
        mov ds,cx
        mov [int5],bl
        pop ds
        mov [di],ah
        in al,21h
        push ds
        mov ds,cx
        mov [int1],al
        pop ds
        mov al,0fdh
        out 21h,al
        sti
        pop di
        pop ds
        pop cx
        pop bx
        pop ax
        ret
setup   endp

unsetup proc
        mov ax,0
        mov ds,ax
        mov di,36
        cli
        push ds
        mov bx,data
        mov ds,bx
        mov al,[int2]
        pop ds
        mov [di],al
        inc di
        push ds
        mov ds,bx
        mov al,[int3]
        pop ds
        mov [di],al
        inc di
        push ds
        mov ds,bx
        mov al,[int4]
        pop ds
        mov [di],al
        inc di
        push ds
        mov ds,bx
        mov al,[int5]
        pop ds
        mov [di],al
        push ds
        mov ds,bx
        mov al,[int1]
        pop ds
        out 21h,al
        sti
        ret
unsetup endp

key     proc
mykey:  push ax
        push bx
        push ds
        in al,060h
        push ax
        in al,061h
        or al,080h
        out 61h,al
        and al,07fh
        out 61h,al
        pop ax
        test al,80h
        jz skip
        mov al,0ffh
skip:   mov dl,al
        mov al,20h
        out 20h,al
        pop ds
        pop bx
        pop ax
        iret
key     endp

screen  proc
        push ax
        push bx
        push cx
        push ds
        mov ax,data
        mov ds,ax
        mov cx,326
        mov ax,0b000h
        mov ds,ax
        mov bx,cx
        mov dh,42
        mov [bx],dh
        mov ax,0b000h
        mov ds,ax
        mov al,88
        mov bx,158
loop2:  mov [bx],al
        dec bx
        dec bx
        jns loop2
        mov bx,160
loop3:  mov [bx],al
        add bx,158
        mov [bx],al
        inc bx
        inc bx
        cmp bx,3680
        jne loop3
loop5:  mov [bx],al
        inc bx
        inc bx
        cmp bx,3840
        jne loop5
bottom: push ax
        push bx
        push ds
        mov ax,data
        mov ds,ax
        mov ax,offset bar
        mov bx,3840
        call print
        pop ds
        pop bx
        pop ax
        pop ds
        pop cx
        pop bx
        pop ax
        ret
screen  endp

print   proc
        push ax
        push bx
        push cx
        push ds
        mov cx,data
        mov ds,cx
;        mov ax,offset bar
        mov di,ax
lop1:   mov al,[di]
        cmp al,0
        je dne1
        push ds
        mov cx,0b000h
        mov ds,cx
        mov [bx],al
        pop ds
        inc bx
        inc bx
        inc di
        jmp lop1
dne1:   pop ds
        pop cx
        pop bx
        pop ax
        ret
print   endp

clear   proc
        push ax
        push bx
        push cx
        push ds
        mov ax,0b000h
        mov ds,ax
        mov al,32
        mov bx,0
loop4:  mov [bx],al
        inc bx
        inc bx
        cmp bx,4002
        jne loop4
        pop ds
        pop cx
        pop bx
        pop ax
        ret
clear   endp

player  proc
        push ax
        push bx
        push cx
        push ds
;        call mvsnake
        mov cx,[new]
        mov ax,0b000h
        mov ds,ax
        mov bx,cx
        mov dh,32
        mov [bx],dh
        mov ax,cx
up:     cmp dl,17h
        jne down
        sub bx,160
down:   cmp dl,25h
        jne left
        add bx,160
left:   cmp dl,24h
        jne right
        dec bx
        dec bx
right:  cmp dl,26h
        jne check
        inc bx
        inc bx
check:  mov dh,79
        cmp [bx],dh
        je pushb
        mov dh,83
        cmp [bx],dh
        jne wall
        call die
        pop ds
        jmp dne2
wall:   mov dh,88
        cmp [bx],dh
        jne space
        mov bx,cx
        jmp done
space:  mov dh,32
        mov cx,bx
        mov bx,ax
        mov [bx],dh
        mov bx,cx
        mov dh,42
        mov [bx],dh
        jmp done
pushb:  mov dh,79  
        cmp [bx],dh
        jne done
        mov dh,dl
        mov al,0
check2: inc al
up2:    cmp dh,17h
        jne down2
        sub bx,160
down2:  cmp dh,25h
        jne left2
        add bx,160
left2:  cmp dh,24h
        jne right2
        dec bx
        dec bx
right2: cmp dh,26h
        jne check3
        inc bx
        inc bx
check3: mov ah,79 ; check if another block
        cmp [bx],ah
        je check2
        mov ah,83 ; check if a snake
        cmp [bx],ah
        je done
        mov ah,88 ; check if border
        cmp [bx],ah
        je done
redraw: mov ah,79
        mov [bx],ah
up3:    cmp dh,17h
        jne down3
        add bx,160
down3:  cmp dh,25h
        jne left3
        sub bx,160
left3:  cmp dh,24h
        jne right3
        inc bx
        inc bx
right3: cmp dh,26h
        jne check4
        dec bx
        dec bx
check4: dec al
        jnz redraw
        mov ah,42
        mov [bx],ah
        mov cx,bx
        mov bx,ax
        mov [bx],dh
done:   mov bx,cx
        mov dh,42
        mov [bx],dh
        pop ds
        mov [new],cx
        mov [old],ax
dne2:   pop cx
        pop bx
        pop ax
        ret
player  endp

random  proc 
        mov ax,0
loop7:  in al,40h
        test al,2
        stc
        jz done3
        clc
done3:  rcl ah,1  
        dec cl
        nop
        nop
        jnz loop7
        mov al,ah
        mov ah,0
        ret
random  endp

blocks  proc
        push ax
        push bx
        push cx
        push ds
        push si
        mov ax,0b000h
        mov ds,ax
        mov si,600
loop6:  mov bx,0
        mov cl,4
        call random
        add bx,ax
        mov cl,2
        call random
        add bx,ax
        mov cl,2
        call random
        add bx,ax
;        inc bx
        dec bx
        mov ax,bx
        mov bl,160
        mul bl
        mov bx,ax
        push bx
        mov bx,0
        mov cl,8
        call random
        add bx,ax
        mov cl,3
        call random
        add bx,ax
        mov cl,3
        call random
        add bx,ax
        rol bx,1
        inc bx
        inc bx
        mov ax,bx
        pop bx
        add bx,ax
        mov al,32
        cmp [bx],al
        jne loop6
        mov al,79
        mov [bx],al
        dec si
        jnz loop6
        pop si
        pop ds
        pop cx
        pop bx
        pop ax
        ret
blocks  endp

mvsnake proc
        push ax
        push bx
        push cx
        push ds
        push si
        mov si,6
        mov ax,data
        mov ds,ax
lop5:   mov bx,snake[si]
        cmp bx,0
        jne ahead2
        dec si
        dec si
        cmp si,0
        jne lop5
        push ax
        push bx
        push ds
        mov ax,data
        mov ds,ax
        mov bx,[new]
        push ds
        mov ax,0b000h
        mov ds,ax
        mov al,32
        mov [bx],al
        pop ds
        mov ax,offset ldone
        mov bx,1812
        call print
        pop ds
        pop bx
        pop ax
        call wait
        call clear
        call screen
        call plives
        call blocks
        push ds
        mov ax,data
        mov ds,ax
        inc [level]
        call plevel
        mov ax,326
        mov [old],ax
        mov [new],ax
        mov bx,ax
        push ds
        mov ax,0b000h
        mov ds,ax
        mov al,42
        mov [bx],al
        pop ds
        mov ax,0
        mov [snake],ax
        mov ax,1000
        mov 2[snake],ax
        mov ax,2000
        mov 4[snake],ax
        mov ax,3000
        mov 6[snake],ax
        pop ds
        jmp dne4
ahead2: mov si,6
loop8:  mov ax,data
        mov ds,ax
        mov bx,snake[si]
        cmp bx,0
        jne ahead1
        jmp nexts
ahead1: mov ax,0b000h
        mov ds,ax
        mov al,32
        mov [bx],al
        mov al,79
square: cmp -162[bx],al
        jne geton
        cmp -160[bx],al
        jne geton
        cmp -158[bx],al
        jne geton
        cmp -2[bx],al
        jne geton
        cmp 2[bx],al
        jne geton
        cmp 158[bx],al
        jne geton
        cmp 160[bx],al
        jne geton
        cmp 162[bx],al
        jne geton
        push ds
        mov ax,data
        mov ds,ax
        mov bx,0
        mov snake[si],bx
        pop ds
        jmp nexts
geton:  mov ax,data
        mov ds,ax
        mov ax,bx
        mov dh,160
        div dh
        mov cl,al
        mov ax,[new]
        mov dh,160
        div dh
        mov ch,al
        cmp ch,cl
        jl sup
        je check5
        add bx,160
        jmp check5
sup:    sub bx,160
check5: mov ax,bx
        mov dh,160
        div dh
        mov cl,ah
        mov ax,[new]
        mov dh,160
        div dh
        mov dh,0
        mov ch,ah
        cmp ch,cl
        jb sup2
        je check6
        add bx,2
        mov dh,1
        jmp check6
sup2:   sub bx,2
        mov dh,2
check6: push ds
        mov ax,0b000h
        mov ds,ax
        mov al,[bx]
        pop ds
        cmp al,32
        je drawsnk
        cmp al,42
        jne fix
        call die
fix:    mov bx,snake[si]
        cmp dh,0
        je drawsnk
        cmp dh,2
        je clft
        add bx,2
        mov dh,0
        jmp check6
clft:   sub bx,2
        mov dh,0
        jmp check6
drawsnk:mov snake[si],bx
        mov ax,0b000h
        mov ds,ax
        mov al,83
        mov [bx],al
nexts:  dec si
        dec si
        jz dne4
        jmp loop8
dne4:   pop si
        pop ds
        pop cx
        pop bx
        pop ax
        ret
mvsnake endp

plives  proc
        push ax
        push bx
        push cx
        push ds
        mov ax,data
        mov ds,ax
        mov al,lives
        add al,48
        mov cx,0b000h
        mov ds,cx
        mov bx,3894
        mov [bx],al
        pop ds
        pop cx
        pop bx
        pop ax
        ret
plives  endp

plevel  proc
        push ax
        push bx
        push cx
        push ds
        mov ax,data
        mov ds,ax
        mov al,level
        add al,48
        mov cx,0b000h
        mov ds,cx
        mov bx,3952
        mov [bx],al
        pop ds
        pop cx
        pop bx
        pop ax
        ret
plevel  endp

die     proc
        push ax
        push bx
        push cx
        push ds
        mov ax,data
        mov ds,ax
        mov bx,[new]
        push ds
        mov ax,0b000h
        mov ds,ax
        mov al,32
        mov [bx],al
        pop ds
        dec [lives]
        call plives
        mov al,[lives]
        cmp al,0
        jne one
        push ax
        push bx
        push ds
        mov ax,data
        mov ds,ax
        mov ax,offset game
        mov bx,1820
        call print
        pop ds
        pop bx
        pop ax
        call wait
        call clear
        call ptitle
        mov ax,data
        mov ds,ax
        mov al,3
        mov [lives],al
        mov al,1
        mov [level],al
        mov ax,326
        mov [new],ax
        mov [old],ax
        mov ax,0
        mov [snake],ax
        mov ax,1000
        mov 2[snake],ax
        mov ax,2000
        mov 4[snake],ax
        mov ax,3000
        mov 6[snake],ax
        call clear
        call screen
        call plives
        call plevel
        call blocks
        jmp dne3
one:    call wait
        mov ax,data
        mov ds,ax
        mov ax,326
        mov [new],ax
        mov [old],ax
        mov ax,0
        mov [snake],ax
        mov ax,2[snake]
        cmp ax,0
        je s2
        push ds
        mov cx,0b000h
        mov ds,cx
        mov bx,ax
        mov cl,32
        mov [bx],cl
        pop ds
        mov ax,1000
        mov 2[snake],ax
s2:     mov ax,4[snake]
        cmp ax,0
        je s4
        push ds
        mov cx,0b000h
        mov ds,cx
        mov bx,ax
        mov cl,32
        mov [bx],cl
        pop ds
        mov ax,2000
        mov 4[snake],ax
s4:     mov ax,6[snake]        
        cmp ax,0
        je dne3
        push ds
        mov cx,0b000h
        mov ds,cx
        mov bx,ax
        mov cl,32
        mov [bx],cl
        pop ds
        mov ax,3000
        mov 6[snake],ax
dne3:   pop ds
        pop cx
        pop bx
        pop ax
        ret
die     endp

main    ends
end     drive
